#!/bin/bash
function make_cn
{
#  N = size of matrix
#  q = file to output to
echo "param: a_1" > $q
for ((i=2; i<=${N}; ++i))
do
    echo "param: a_${i}" >> $q
done

for ((i=1; i<=${N}; ++i))
do
    for ((j=i+1; j<=${N}; ++j))
    do
	echo "param: b_${i}_${j}" >> $q
    done
done

echo

for ((i=1; i<=${N}; ++i))
do
    echo "var: x_${i}" >> $q
done

echo

for ((i=1; i<=${N}; ++i))
do
    echo "term: a_${i} * x_${i}" >> $q
done

echo

for ((i=1; i<=${N}; ++i))
do
    for ((j=i+1; j<=${N}; ++j))
    do
	echo "term: b_${i}_${j} * x_${i} * x_${j}" >> $q
    done
done
}
function check_dw
{

wspace=$DW_INTERNAL__WORKSPACE
con=$DW_INTERNAL__CONNECTION
wspath=$DW_INTERNAL__WSPATH
sol=$DW_INTERNAL__SOLVER
#
error=FALSE
if [ -z $con ]
then
    echo Error no connection exist
    error=TRUE
fi
if [ -z $sol ]
then
    echo Error no solver exist
    error=TRUE
fi
if [[ -n $wspace ]]
then
    :
else
    echo Workspace directory not set
    error=TRUE
fi

if [ $error = "TRUE" ]
then
    echo abort script
    exit 1
fi
}
function pick_embed
{
    grep maximum ${mytmp}/*$N.out* > ${mytmp}/maxchain
    grep qubit   ${mytmp}/*$N.out* > ${mytmp}/qubits
    ls -1 ${mytmp}/epqmi.$N* > ${mytmp}/fnames
    cut -f 2 -d = ${mytmp}/maxchain > ${mytmp}/maxchain.num
    cut -f 2 -d = ${mytmp}/qubits > ${mytmp}/qubits.num
    paste ${mytmp}/fnames ${mytmp}/maxchain.num ${mytmp}/qubits.num > ${mytmp}/list
    best_embed=`sort -k 2rn -k 3rn ${mytmp}/list|tail -n1|cut -f 1`
    #      /tmp/16706/epqmi.16.8  10  140
    echo  "epqmi filename       maxchain   qubits"
    sort -k 2rn -k 3rn ${mytmp}/list

}
function find_embed
{
    fnd=lostit
    for (( j=1; j<= 4; j++))
    do
        dw embed $q > $qe.$i 2>&1
        if  grep --silent ERROR $qe.$i ; then
            echo Didn\'t find c.$N embed on try number $j,  iteration $i
            continue
        else
            dw cp default.epqmi ${mytmp}/epqmi.$N.$i > /dev/null 2>&1
            fnd=foundit
            break
        fi
    done
}
function mk_embed
{
  if [ ! -d $wspace/full.${N} ]; then
    mkdir $wspace/full.${N}
  fi
    q=${mytmp}/c.${N}.q
    qe=${mytmp}/embed.${N}.out
    q_epqmi=${mytmp}/epqmi.${N}

    make_cn
    echo "make cn" ${N}
    dw cd /full.${N} > /dev/null 2>&1

  for ((i=1; i<=25; ++i))
  do
    find_embed
    if (($fnd==lostit)); then
        break
    fi
  done
}

##  main

myPID=$$
mytmp=/tmp/${myPID}
mkdir ${mytmp}
foundit=1
lostit=0

fnd=foundit
check_dw
M=`grep "M:" ${DW_INTERNAL__WORKSPACE}/geometry|cut -f2  -d:`
M=`echo $M | tr -dc '[:alnum:]\n\r' | tr '[:upper:]' '[:lower:]'`
echo $M
case "${M}" in
    *4*)
        start=16
        echo start=16
        ;;
    *12*)
        start=44
        echo start=44
        ;;
    *16*)
        start=62
        echo start=62
        ;;
     *)
        start=16
        echo start=16 default
esac

for (( N=${start}; N<= 150; N++))
do
    mk_embed
    if (( $fnd==lostit )); then
        let n=${N}-1
        # remove all the temp directories
        mv $DW_INTERNAL__WORKSPACE/full.${n} $DW_INTERNAL__WORKSPACE/holdit
        mv $DW_INTERNAL__WORKSPACE/full.* /tmp  
        mv $DW_INTERNAL__WORKSPACE/holdit $DW_INTERNAL__WORKSPACE/full.${n}
        echo largest embed found ${n}
        echo full.${n} > $DW_INTERNAL__WORKSPACE/.max_full
        break
    fi
    pick_embed
    dw cp $best_embed default.epqmi > /dev/null 2>&1
    echo dw cp $best_embed default.epqmi
    echo $N >  $DW_INTERNAL__WORKSPACE/$DW_INTERNAL__WSPATH/.epqmi_max
done
#rm -rf $mytmp
rm -rf $wspace/full.$N
